#include "../include/keycodes_conv.h"

#include "../include/defines.h"

#include <stdio.h>
#include <string.h>

const keyCode keycodes[] = {

    KEYCODE(KEY_NONE),
    KEYCODE(KEY_ErrorRollOver),
    KEYCODE(KEY_POSTFail),
    KEYCODE(KEY_ErrorUndefined),
    KEYCODE(KEY_a_A),
    KEYCODE(KEY_b_B),
    KEYCODE(KEY_c_C),
    KEYCODE(KEY_d_D),
    KEYCODE(KEY_e_E),
    KEYCODE(KEY_f_F),
    KEYCODE(KEY_g_G),
    KEYCODE(KEY_h_H),
    KEYCODE(KEY_i_I),
    KEYCODE(KEY_j_J),
    KEYCODE(KEY_k_K),
    KEYCODE(KEY_l_L),
    KEYCODE(KEY_m_M),
    KEYCODE(KEY_n_N),
    KEYCODE(KEY_o_O),
    KEYCODE(KEY_p_P),
    KEYCODE(KEY_q_Q),
    KEYCODE(KEY_r_R),
    KEYCODE(KEY_s_S),
    KEYCODE(KEY_t_T),
    KEYCODE(KEY_u_U),
    KEYCODE(KEY_v_V),
    KEYCODE(KEY_w_W),
    KEYCODE(KEY_x_X),
    KEYCODE(KEY_y_Y),
    KEYCODE(KEY_z_Z),
    KEYCODE(KEY_1_Exclamation),
    KEYCODE(KEY_2_At),
    KEYCODE(KEY_3_Pound),
    KEYCODE(KEY_4_Dollar),
    KEYCODE(KEY_5_Percent),
    KEYCODE(KEY_6_Caret),
    KEYCODE(KEY_7_Ampersand),
    KEYCODE(KEY_8_Asterisk),
    KEYCODE(KEY_9_LeftParenthesis),
    KEYCODE(KEY_0_RightParenthesis),
    KEYCODE(KEY_ReturnEnter),
    KEYCODE(KEY_Escape),
    KEYCODE(KEY_DeleteBackspace),
    KEYCODE(KEY_Tab),
    KEYCODE(KEY_Spacebar),
    KEYCODE(KEY_Dash_Underscore),
    KEYCODE(KEY_Equal_Plus),
    KEYCODE(KEY_LeftBracket_LeftBrace),
    KEYCODE(KEY_RightBracket_RightBrace),
    KEYCODE(KEY_Backslash_Pipe),
    KEYCODE(KEY_NonUS_Pound_Tilde),
    KEYCODE(KEY_Semicolon_Colon),
    KEYCODE(KEY_SingleQuote_DoubleQuote),
    KEYCODE(KEY_GraveAccent_Tilde),
    KEYCODE(KEY_Comma_LessThan),
    KEYCODE(KEY_Period_GreaterThan),
    KEYCODE(KEY_Slash_Question),
    KEYCODE(KEY_CapsLock),
    KEYCODE(KEY_F1),
    KEYCODE(KEY_F2),
    KEYCODE(KEY_F3),
    KEYCODE(KEY_F4),
    KEYCODE(KEY_F5),
    KEYCODE(KEY_F6),
    KEYCODE(KEY_F7),
    KEYCODE(KEY_F8),
    KEYCODE(KEY_F9),
    KEYCODE(KEY_F10),
    KEYCODE(KEY_F11),
    KEYCODE(KEY_F12),
    KEYCODE(KEY_PrintScreen),
    KEYCODE(KEY_ScrollLock),
    KEYCODE(KEY_Pause),
    KEYCODE(KEY_Insert),
    KEYCODE(KEY_Home),
    KEYCODE(KEY_PageUp),
    KEYCODE(KEY_DeleteForward),
    KEYCODE(KEY_End),
    KEYCODE(KEY_PageDown),
    KEYCODE(KEY_RightArrow),
    KEYCODE(KEY_LeftArrow),
    KEYCODE(KEY_DownArrow),
    KEYCODE(KEY_UpArrow),
    KEYCODE(KEYPAD_NumLock_Clear),
    KEYCODE(KEYPAD_Slash),
    KEYCODE(KEYPAD_Asterisk),
    KEYCODE(KEYPAD_Minus),
    KEYCODE(KEYPAD_Plus),
    KEYCODE(KEYPAD_ENTER),
    KEYCODE(KEYPAD_1_End),
    KEYCODE(KEYPAD_2_DownArrow),
    KEYCODE(KEYPAD_3_PageDown),
    KEYCODE(KEYPAD_4_LeftArrow),
    KEYCODE(KEYPAD_5),
    KEYCODE(KEYPAD_6_RightArrow),
    KEYCODE(KEYPAD_7_Home),
    KEYCODE(KEYPAD_8_UpArrow),
    KEYCODE(KEYPAD_9_PageUp),
    KEYCODE(KEYPAD_0_Insert),
    KEYCODE(KEYPAD_Period_Delete),
    KEYCODE(KEY_NonUS_Backslash_Pipe),
    KEYCODE(KEY_Application),
    KEYCODE(KEY_Power),
    KEYCODE(KEYPAD_Equal),
    KEYCODE(KEY_F13),
    KEYCODE(KEY_F14),
    KEYCODE(KEY_F15),
    KEYCODE(KEY_F16),
    KEYCODE(KEY_F17),
    KEYCODE(KEY_F18),
    KEYCODE(KEY_F19),
    KEYCODE(KEY_F20),
    KEYCODE(KEY_F21),
    KEYCODE(KEY_F22),
    KEYCODE(KEY_F23),
    KEYCODE(KEY_F24),
    KEYCODE(KEY_Execute),
    KEYCODE(KEY_Help),
    KEYCODE(KEY_Menu),
    KEYCODE(KEY_Select),
    KEYCODE(KEY_Stop),
    KEYCODE(KEY_Again),
    KEYCODE(KEY_Undo),
    KEYCODE(KEY_Cut),
    KEYCODE(KEY_Copy),
    KEYCODE(KEY_Paste),
    KEYCODE(KEY_Find),
    KEYCODE(KEY_Mute),
    KEYCODE(KEY_VolumeUp),
    KEYCODE(KEY_VolumeDown),
    KEYCODE(KEY_LockingCapsLock),
    KEYCODE(KEY_LockingNumLock),
    KEYCODE(KEY_LockingScrollLock),
    KEYCODE(KEYPAD_Comma),
    KEYCODE(KEYPAD_EqualSign),
    KEYCODE(KEY_International1),
    KEYCODE(KEY_International2),
    KEYCODE(KEY_International3),
    KEYCODE(KEY_International4),
    KEYCODE(KEY_International5),
    KEYCODE(KEY_International6),
    KEYCODE(KEY_International7),
    KEYCODE(KEY_International8),
    KEYCODE(KEY_International9),
    KEYCODE(KEY_LANG1),
    KEYCODE(KEY_LANG2),
    KEYCODE(KEY_LANG3),
    KEYCODE(KEY_LANG4),
    KEYCODE(KEY_LANG5),
    KEYCODE(KEY_LANG6),
    KEYCODE(KEY_LANG7),
    KEYCODE(KEY_LANG8),
    KEYCODE(KEY_LANG9),
    KEYCODE(KEY_AlternateErase),
    KEYCODE(KEY_SysReq_Attention),
    KEYCODE(KEY_Cancel),
    KEYCODE(KEY_Clear),
    KEYCODE(KEY_Prior),
    KEYCODE(KEY_Return),
    KEYCODE(KEY_Separator),
    KEYCODE(KEY_Out),
    KEYCODE(KEY_Oper),
    KEYCODE(KEY_Clear_Again),
    KEYCODE(KEY_CrSel_Props),
    KEYCODE(KEY_ExSel),
    KEYCODE(KEYPAD_00),
    KEYCODE(KEYPAD_000),
    KEYCODE(KEY_ThousandsSeparator),
    KEYCODE(KEY_DecimalSeparator),
    KEYCODE(KEY_CurrencyUnit),
    KEYCODE(KEY_CurrencySubunit),
    KEYCODE(KEYPAD_LeftParenthesis),
    KEYCODE(KEYPAD_RightParenthesis),
    KEYCODE(KEYPAD_LeftBrace),
    KEYCODE(KEYPAD_RightBrace),
    KEYCODE(KEYPAD_Tab),
    KEYCODE(KEYPAD_Backspace),
    KEYCODE(KEYPAD_A),
    KEYCODE(KEYPAD_B),
    KEYCODE(KEYPAD_C),
    KEYCODE(KEYPAD_D),
    KEYCODE(KEYPAD_E),
    KEYCODE(KEYPAD_F),
    KEYCODE(KEYPAD_XOR),
    KEYCODE(KEYPAD_Caret),
    KEYCODE(KEYPAD_Percent),
    KEYCODE(KEYPAD_LessThan),
    KEYCODE(KEYPAD_GreaterThan),
    KEYCODE(KEYPAD_Ampersand),
    KEYCODE(KEYPAD_AmpersandAmpersand),
    KEYCODE(KEYPAD_Pipe),
    KEYCODE(KEYPAD_PipePipe),
    KEYCODE(KEYPAD_Colon),
    KEYCODE(KEYPAD_Pound),
    KEYCODE(KEYPAD_Space),
    KEYCODE(KEYPAD_At),
    KEYCODE(KEYPAD_Exclamation),
    KEYCODE(KEYPAD_MemoryStore),
    KEYCODE(KEYPAD_MemoryRecall),
    KEYCODE(KEYPAD_MemoryClear),
    KEYCODE(KEYPAD_MemoryAdd),
    KEYCODE(KEYPAD_MemorySubtract),
    KEYCODE(KEYPAD_MemoryMultiply),
    KEYCODE(KEYPAD_MemoryDivide),
    KEYCODE(KEYPAD_PlusMinus),
    KEYCODE(KEYPAD_Clear),
    KEYCODE(KEYPAD_ClearEntry),
    KEYCODE(KEYPAD_Binary),
    KEYCODE(KEYPAD_Octal),
    KEYCODE(KEYPAD_Decimal),
    KEYCODE(KEYPAD_Hexadecimal),
    KEYCODE(KEY_LeftControl),
    KEYCODE(KEY_LeftShift),
    KEYCODE(KEY_LeftAlt),
    KEYCODE(KEY_LeftGUI),
    KEYCODE(KEY_RightControl),
    KEYCODE(KEY_RightShift),
    KEYCODE(KEY_RightAlt),
    KEYCODE(KEY_RightGUI),

    /* SPECIAL KEYCODES FOR THE MODIFIFER KEY */
    KEYCODE(MODKEY_NONE),
    KEYCODE(MODKEY_LCTR),
    KEYCODE(MODKEY_LSHI),
    KEYCODE(MODKEY_LALT),
    KEYCODE(MODKEY_LWIN),
    KEYCODE(MODKEY_RCTR),
    KEYCODE(MODKEY_RSHI),
    KEYCODE(MODKEY_RALT),
    KEYCODE(MODKEY_RWIN),
    KEYCODE(MODKEY_RWIN_RSHI),
    KEYCODE(MODKEY_RWIN_RCTR),
    KEYCODE(MODKEY_RWIN_RALT),
    KEYCODE(MODKEY_RWIN_RCTR_RSHI),
    KEYCODE(MODKEY_RCTR_RALT),
    KEYCODE(MODKEY_RCTR_RSHI),
    KEYCODE(MODKEY_RALT_RSHI),
    KEYCODE(MODKEY_RALT_RCTR_RSHI),
};

uint8_t
get_keycode_by_name(char *key_name) {
    uint8_t keycode = 0x00;

    for (int i = 0; i < (sizeof(keycodes) / sizeof(keycodes[0])); i++) {
        if (strcmp(keycodes[i].key_name, key_name) == 0) {
            keycode = keycodes[i].key_code;
            break;
        }
    }

    return keycode;
}
